Index: branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Parsers/CordeauParser.cs
===================================================================
--- branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Parsers/CordeauParser.cs	(revision 6851)
+++ branches/VRP/HeuristicLab.Problems.VehicleRouting/3.4/Parsers/CordeauParser.cs	(revision 6851)
@@ -0,0 +1,180 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.Text.RegularExpressions;
+
+namespace HeuristicLab.Problems.VehicleRouting.Parsers {
+  class CordeauParser {
+    private string file;
+    private string problemName;
+    private int cities;
+    private int depots;
+    private int vehicles;
+    private List<double> capacity;
+    private List<double> xCoord;
+    private List<double> yCoord;
+    private List<double> demand;
+    private List<double> readyTime;
+    private List<double> dueTime;
+    private List<double> serviceTime;
+
+    public int Cities {
+      get {
+        return cities;
+      }
+    }
+
+    public int Depots {
+      get {
+        return depots;
+      }
+    }
+
+    public int Vehicles {
+      get {
+        return vehicles;
+      }
+    }
+
+    public double[] Capacity {
+      get {
+        return capacity.ToArray();
+      }
+    }
+
+    public double[,] Coordinates {
+      get {
+        double[] x = xCoord.ToArray();
+        double[] y = yCoord.ToArray();
+        double[,] coord = new double[x.Length, 2];
+        for (int i = 0; i < x.Length; i++) {
+          coord[i, 0] = x[i];
+          coord[i, 1] = y[i];
+        }
+        return coord;
+      }
+    }
+
+    public double[] Demands {
+      get {
+        return demand.ToArray();
+      }
+    }
+
+    public double[] Readytimes {
+      get {
+        return readyTime.ToArray();
+      }
+    }
+
+    public double[] Duetimes {
+      get {
+        return dueTime.ToArray();
+      }
+    }
+
+    public double[] Servicetimes {
+      get {
+        return serviceTime.ToArray();
+      }
+    }
+
+    public String ProblemName {
+      get {
+        return problemName;
+      }
+    }
+
+    public CordeauParser(string file) {
+      this.file = file;
+      capacity = new List<double>();
+      xCoord = new List<double>();
+      yCoord = new List<double>();
+      demand = new List<double>();
+      readyTime = new List<double>();
+      dueTime = new List<double>();
+      serviceTime = new List<double>();
+    }
+
+    public void Parse() {
+      string line;
+      Regex reg = new Regex(@"-?\d+(\.\d+)?");
+      MatchCollection m;
+
+      StreamReader reader = new StreamReader(file);
+
+      problemName = Path.GetFileNameWithoutExtension(file);
+      line = reader.ReadLine();
+
+      m = reg.Matches(line);
+      if (m.Count != 4)
+        throw new InvalidDataException("File has wrong format!");
+
+      vehicles = int.Parse(m[3].Value);
+      line = reader.ReadLine();
+
+      for (int i = 0; i < vehicles; i++) {
+        m = reg.Matches(line);
+        if (m.Count != 2) { continue; }
+
+        capacity.Add(double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture));
+
+        line = reader.ReadLine();
+      }
+
+      List<double> depotXcoord = new List<double>();
+      List<double> depotYcoord = new List<double>();
+      while ((line != null)) {
+        m = reg.Matches(line);
+
+        if (m.Count == 11) {
+          xCoord.Add(double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture));
+          yCoord.Add(double.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture));
+          demand.Add((double)int.Parse(m[4].Value, System.Globalization.CultureInfo.InvariantCulture));
+        } else if (m.Count == 7) {
+          depotXcoord.Add(double.Parse(m[1].Value, System.Globalization.CultureInfo.InvariantCulture));
+          depotYcoord.Add(double.Parse(m[2].Value, System.Globalization.CultureInfo.InvariantCulture));
+        }
+               
+        line = reader.ReadLine();
+      }
+
+      xCoord.InsertRange(0, depotXcoord);
+      yCoord.InsertRange(0, depotYcoord);
+
+      cities = demand.Count;
+      depots = depotXcoord.Count;
+
+      vehicles *= depots;
+      List<double> originalCapacities = new List<double>(capacity);
+      for (int i = 1; i < depots; i++) {
+        capacity.InsertRange(0, originalCapacities);
+      }
+    }
+
+    internal string OnReset() {
+      throw new NotImplementedException();
+    }
+  }
+}
